 --assign logical name to macro keyboard
--lmc_assign_keyboard('PED');
--lmc_assign_keyboard('AP');
--lmc_device_set_name('FMC', 'E47F71A') -- USBreceiver in the front??

lmc_device_set_name('AP', '75D64B2') -- AP-dedicated
lmc_device_set_name('PED', '1FD7066A') -- Pedestal

lmc_device_set_name('CH_Yoke', 'DAEC7510') -- CH-Eclipse Yoke
lmc_device_set_name('CH_Quadrant', 'CH Throttle Quadrant USB') -- CH-Quadrant
lmc_device_set_name('CH_Pedals',  'CH Pro Pedals USB') -- CH-Pro Pedals
--lmc_device_set_name('Stick', '325D0AA0') -- Flightstick

print (lmc_print_devices())

--  COMMANDOPTIONS TEST
--  if     (button == string.byte('A')) then lmc_spawn("calc")
--  elseif (button == string.byte('N')) then lmc_spawn("notepad", "C:\\test.txt")
--  elseif (button == string.byte('G')) then lmc_say('Gears up')
--  if (button == string.byte('A')) then lmc_send_keys('AA')
--  elseif (button == string.byte('G')) then lmc_send_keys('g')
  --elseif (button == 112) then lmc_say('Gear sup') -- 112=F1
  --elseif (button == 113) then lmc_xpl_command_begin('sim/engines/engage_starters')
--if (button == 112) then lmc_xpl_command('Rotate/md80/fuel/pump_fwd_R_On')
--elseif (button == 113) then lmc_xpl_command('Rotate/md80/fuel/pump_fwd_R_Off')


-- Globals:
CtrlUp = true;


-- **** AP Keyboard BEGIN ****

-- define callback for whole device
lmc_set_handler('AP',function(button, direction)

--All simulated ccrollwheels/knobs works with keyrepettitor on keydowns
--buttons and switches works on keyreleases (keyups):

  if (direction == 1) then -- (keydowns)

     if (button == 17) then CtrlUp = false;

     -- following command means: decrease value by 1, when "underflow" below 0, start from 360
     -- following command means: increase value by 1, when overflow 360, start from 0

     -- NAV1 :
     elseif (button == 50) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav1_freq', 1)
     elseif (button == 51) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav1_freq_fine', 1)
     elseif (button == 52) then lmc_xpl_command('Rotate/md80/autopilot/nav1_crs_more')
     elseif (button == string.byte('W')) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav1_freq', -1)
     elseif (button == string.byte('E')) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav1_freq_fine', -1)
     elseif (button == string.byte('R')) then lmc_xpl_command('Rotate/md80/autopilot/nav1_crs_less')
     -- NAV2 :
     elseif (button == 45) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav2_freq', 1)
     elseif (button == 36) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav2_freq_fine', 1)
     elseif (button == 33) then lmc_xpl_command('Rotate/md80/autopilot/nav2_crs_more')
     elseif (button == 46) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav2_freq', -1)
     elseif (button == 35) then lmc_inc_xpl_variable('Rotate/md80/autopilot/nav2_freq_fine', -1)
     elseif (button == 34) then lmc_xpl_command('Rotate/md80/autopilot/nav2_crs_less')

     -- SPD :
     elseif (button == 112) then lmc_xpl_command('Rotate/md80/autopilot/speed_sel_less')
     elseif (button == 113) then lmc_xpl_command('Rotate/md80/autopilot/speed_sel_more')
     -- HDG :
     elseif (button == 116) then lmc_xpl_command('Rotate/md80/autopilot/hdg_sel_less')
     elseif (button == 117) then lmc_xpl_command('Rotate/md80/autopilot/hdg_sel_more')
     -- ALT :
     --elseif (button == 120) then lmc_xpl_command('Rotate/md80/autopilot/alt_sel_less')
     elseif (button == 120) then lmc_inc_xpl_variable('Rotate/md80/autopilot/alt_sel_ft', -10)
     elseif (button == 121) then lmc_inc_xpl_variable('Rotate/md80/autopilot/alt_sel_ft', -1)
     elseif (button == 122) then lmc_inc_xpl_variable('Rotate/md80/autopilot/alt_sel_ft', 1)
     elseif (button == 123) then lmc_inc_xpl_variable('Rotate/md80/autopilot/alt_sel_ft', 10)
     --elseif (button == 123) then lmc_xpl_command('Rotate/md80/autopilot/alt_sel_more')
     -- VS :
     elseif (button == 192) then lmc_xpl_command('Rotate/md80/autopilot/pcw_more')
     elseif (button == string.byte('P')) then lmc_xpl_command('Rotate/md80/autopilot/pcw_less')

     end
	 return -- ignore rest on keydown
  end

  --Keyups:
  -- On keyups the above knowkeys should be ignored.
  if   ( button == 112 or button == 113
     or button == 116 or button == 117
     or button == 120 or button == 121
     or button == 122 or button == 123
     or button == 50 or button == string.byte('W')
     or button == 51 or button == string.byte('E')
     or button == 52 or button == string.byte('R')
     or button == 45 or button == string.byte('P')
     or button == 46 or button == 192
     or button == 36 or button == 35
     or button == 33 or button == 34

     ) then return end

  if     (button == 17) then
         CtrlUp = true;

  -- F-keys :
  elseif (button == 114) then lmc_xpl_command('Rotate/md80/autopilot/spd_mach_toggle')
  elseif (button == 115 and CtrlUp) then lmc_xpl_command('Rotate/md80/autopilot/at_switch_on')
  elseif (button == 115 and not CtrlUp) then lmc_xpl_command('Rotate/md80/autopilot/at_switch_off')
  elseif (button == 118) then lmc_xpl_command('Rotate/md80/autopilot/hdg_hold_mode')
  elseif (button == 119) then lmc_xpl_command('Rotate/md80/autopilot/hdg_sel_mode')

  -- Top Row:
  elseif (button == 220) then lmc_xpl_command('Rotate/md80/systems/clear_master_warning')
  elseif (button == 49) then lmc_xpl_command('Rotate/md80/systems/clear_master_caution')
  elseif (button == 53 and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/autopilot/fd_toggle', 1)
  elseif (button == 53 and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/autopilot/fd_toggle', 0)
  elseif (button == 54) then lmc_xpl_command('Rotate/md80/autopilot/spd_sel')
  elseif (button == 55) then lmc_xpl_command('Rotate/md80/autopilot/nav_mode')
  elseif (button == 56) then lmc_xpl_command('Rotate/md80/autopilot/vorloc_mode')
  elseif (button == 57) then lmc_inc_xpl_variable('Rotate/md80/autopilot/bank_angle_mode', -1)
  elseif (button == 48) then lmc_inc_xpl_variable('Rotate/md80/autopilot/bank_angle_mode', 1)
  elseif (button == 187) then lmc_xpl_command('Rotate/md80/autopilot/v_speed_sel')
  elseif (button == 219) then lmc_xpl_command('Rotate/md80/autopilot/alt_hold_sel')
  elseif (button == 8) then lmc_xpl_command('Rotate/md80/autopilot/alt_hold_arm')


  -- Letter Upper Row:
  elseif (button == 9 and CtrlUp) then
         lmc_inc_xpl_variable('Rotate/md80/lights/wing_ldg_light_switch_r', 1)
         lmc_inc_xpl_variable('Rotate/md80/lights/wing_ldg_light_switch_l', 1)
  elseif (button == 9 and not CtrlUp) then
         lmc_inc_xpl_variable('Rotate/md80/lights/wing_ldg_light_switch_r', -1)
         lmc_inc_xpl_variable('Rotate/md80/lights/wing_ldg_light_switch_l', -1)
  elseif (button == string.byte('Q') and CtrlUp) then
         lmc_inc_xpl_variable('Rotate/md80/lights/nose_light_switch', 1)
  elseif (button == string.byte('Q') and not CtrlUp) then
         lmc_inc_xpl_variable('Rotate/md80/lights/nose_light_switch', -1)
--elseif (button == string.byte('T'))
  elseif (button == string.byte('Y')) then lmc_xpl_command('Rotate/md80/autopilot/mach_sel')
--elseif (button == string.byte('U'))
  elseif (button == string.byte('I')) then lmc_xpl_command('Rotate/md80/autopilot/ils_mode')
--elseif (button == string.byte('O'))
  elseif (button == 221) then lmc_xpl_command('Rotate/md80/autopilot/ias_mach_sel')
  elseif (button == 186 and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/autopilot/fd_toggle', 1)
  elseif (button == 186 and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/autopilot/fd_toggle', 0)
  elseif (button == 13) then lmc_xpl_command('Rotate/md80/autopilot/ap_toggle')

  -- Letter Mid Row:
  elseif (button == string.byte('A') and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/nav_display_mode',1)
  elseif (button == string.byte('A') and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/nav_display_mode',-1)
  elseif (button == string.byte('S') and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/instruments/nav_display_show_adf1',0)
  elseif (button == string.byte('S') and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/instruments/nav_display_show_adf1',1)
  elseif (button == string.byte('D') and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/instruments/nav_display_show_adf2',0)
  elseif (button == string.byte('D') and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/instruments/nav_display_show_adf2',1)
  elseif (button == string.byte('F')) then lmc_inc_xpl_variable('Rotate/md80/instruments/nav_display_range',-1)
  elseif (button == string.byte('G')) then lmc_xpl_command('Rotate/md80/autopilot/at_fms_override')
  elseif (button == string.byte('H')) then lmc_xpl_command('Rotate/md80/autopilot/epr_sel')
--elseif (button == string.byte('J'))
--elseif (button == string.byte('K')) (Reserved for Autoland)
--elseif (button == string.byte('L'))
  elseif (button == 222) then lmc_xpl_command('Rotate/md80/autopilot/vnav_sel')
  elseif (button == 191) then lmc_inc_xpl_variable('Rotate/md80/autopilot/ap_side_selector', 1, 1, 0)


  -- Letter Lower Row:
  elseif (button == 226) then lmc_xpl_command('Rotate/md80/instruments/navaid_button')
  elseif (button == string.byte('Z')) then lmc_xpl_command('Rotate/md80/instruments/airport_button')
  elseif (button == string.byte('X')) then lmc_xpl_command('Rotate/md80/instruments/data_button')
  elseif (button == string.byte('C')) then lmc_xpl_command('Rotate/md80/instruments/waypoint_button')
  elseif (button == string.byte('V')) then lmc_inc_xpl_variable('Rotate/md80/instruments/nav_display_range',1)
  elseif (button == string.byte('B') and CtrlUp) then lmc_xpl_command_begin('Rotate/md80/test/test_fire_loop_a')
  elseif (button == string.byte('B') and not CtrlUp) then lmc_xpl_command_end('Rotate/md80/test/test_fire_loop_a')
  elseif (button == string.byte('N')) then lmc_xpl_command('Rotate/md80/systems/fire_bell_off')
  elseif (button == string.byte('M') and CtrlUp) then lmc_xpl_command_begin('Rotate/md80/test/test_fire_loop_b')
  elseif (button == string.byte('M') and not CtrlUp) then lmc_xpl_command_end('Rotate/md80/test/test_fire_loop_b')
  elseif (button == 190 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/engines/art_switch',1)
  elseif (button == 190 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/engines/art_switch',-1)
  elseif (button == 32) then lmc_xpl_command('Rotate/md80/systems/parking_brake_toggle')

  --arrows:
--elseif (button == 37 and CtrlUp) then lmc_xpl_command_begin('')  --left
  elseif (button == 39 and CtrlUp) then lmc_xpl_command('Rotate/md80/fuel/zfw_button')  --right
  elseif (button == 38) then lmc_xpl_command('sim/flight_controls/landing_gear_up')  --up
  elseif (button == 40) then lmc_xpl_command('sim/flight_controls/landing_gear_down')  --down

  -- Numpad:
--elseif (button == 96) then lmc_xpl_command('Rotate/md80/cdu/Cdu_0')--numpad_0
  elseif (button == 97) then lmc_xpl_command('Rotate/md80/autopilot/epr_con_mode')
  elseif (button == 98) then lmc_xpl_command('Rotate/md80/autopilot/epr_clb_mode')
  elseif (button == 99) then lmc_xpl_command('Rotate/md80/autopilot/epr_crz_mode')
  elseif (button == 100) then lmc_xpl_command('Rotate/md80/autopilot/epr_to_mode')
  elseif (button == 101) then lmc_xpl_command('Rotate/md80/autopilot/epr_toflex_mode')
  elseif (button == 102) then lmc_xpl_command('Rotate/md80/autopilot/epr_ga_mode')
  elseif (button == 103 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/autopilot/epr_toflex_temp_knob',1)
  elseif (button == 103 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/autopilot/epr_toflex_temp_knob',-1)
  elseif (button == 104 and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/lights/wing_light_switch',1)
  elseif (button == 104 and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/lights/wing_light_switch',0)
  elseif (button == 105 and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/lights/anticollision_light_switch',1)--numpad_9
  elseif (button == 105 and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/lights/anticollision_light_switch',0)

  elseif (button == 110) then lmc_xpl_command('Rotate/md80/autopilot/trp_test') --numpad.
  elseif (button == 107 and CtrlUp) then                                        --numpad+
     lmc_inc_xpl_variable('Rotate/md80/lights/pos_strobe_light_switch',1)
  elseif (button == 107 and not CtrlUp) then
     lmc_inc_xpl_variable('Rotate/md80/lights/pos_strobe_light_switch',-1)
  elseif (button == 111 and CtrlUp) then                                        --numpad/
     lmc_set_xpl_variable('Rotate/md80/lights/flood_light_switch_l',1)
     lmc_set_xpl_variable('Rotate/md80/lights/flood_light_switch_r',1)
  elseif (button == 111 and not CtrlUp) then
     lmc_set_xpl_variable('Rotate/md80/lights/flood_light_switch_l',0)
     lmc_set_xpl_variable('Rotate/md80/lights/flood_light_switch_r',0)
  elseif (button == 106) then lmc_xpl_command('Rotate/md80/systems/clear_master_caution')--numpad*
  elseif (button == 109) then lmc_xpl_command('Rotate/md80/systems/clear_master_warning')--numpad-



  elseif (button == 36) then lmc_xpl_command('sim/view/quick_look_10') --/home
  --Do not use quick_look_1, tapping twice doesn't return to the last view.

--  elseif (button == string.byte('D')) then lmc_xpl_command('sim/fms/dep_arr')
--  elseif (button == string.byte('E')) then lmc_xpl_command('sim/fms/exec')
  else print('Not yet assigned: ' .. button)
  end
end)
-- **** AP Keyboard END ****

-- *************************

-- *************************

-- *************************

-- *************************

-- *************************

-- *************************

-- *************************

-- **** Pedestal / lower central panel Keyboard BEGIN ****

-- define callback for whole device
lmc_set_handler('PED',function(button, direction)

  if (direction == 1) then -- (keydowns)

     if (button == 17) then CtrlUp = false;

  -- VHF1 :
     elseif (button == 53)                 then lmc_inc_xpl_variable('Rotate/md80/autopilot/com1_freq', 1)
     elseif (button == 54)                 then lmc_inc_xpl_variable('Rotate/md80/autopilot/com1_freq_fine', 1)
     elseif (button == string.byte('T') )  then lmc_inc_xpl_variable('Rotate/md80/autopilot/com1_freq', -1)
     elseif (button == string.byte('Y') )  then lmc_inc_xpl_variable('Rotate/md80/autopilot/com1_freq_fine', -1)

  -- VHF2 :
     elseif (button == 57)                 then lmc_inc_xpl_variable('Rotate/md80/autopilot/com2_freq', 1)
     elseif (button == 48)                 then lmc_inc_xpl_variable('Rotate/md80/autopilot/com2_freq_fine', 1)
     elseif (button == string.byte('O') )  then lmc_inc_xpl_variable('Rotate/md80/autopilot/com2_freq', -1)
     elseif (button == string.byte('P') )  then lmc_inc_xpl_variable('Rotate/md80/autopilot/com2_freq_fine', -1)

  -- ADF1 :
     elseif (button == string.byte('F'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf1_freq_hundreds', 1)
     elseif (button == string.byte('G'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf1_freq_tens', 1)
     elseif (button == string.byte('H'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf1_freq_ones', 1)
     elseif (button == string.byte('V'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf1_freq_hundreds', -1)
     elseif (button == string.byte('B'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf1_freq_tens', -1)
     elseif (button == string.byte('N'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf1_freq_ones', -1)

  -- ADF2 :
     elseif (button == string.byte('K'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf2_freq_hundreds', 1)
     elseif (button == string.byte('L'))   then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf2_freq_tens', 1)
     elseif (button == 192)                then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf2_freq_ones', 1)
     elseif (button == 188)                then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf2_freq_hundreds', -1)
     elseif (button == 190)                then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf2_freq_tens', -1)
     elseif (button == 189)                then lmc_inc_xpl_variable('Rotate/md80/autopilot/adf2_freq_ones', -1)


  -- BRTN:
     elseif (button == 111 and CtrlUp)     then lmc_inc_xpl_variable('Rotate/md80/lights/cockpit_panel_instr_lt_dimm', 0.05)    --num /
     elseif (button == 111 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/lights/cockpit_panel_instr_lt_dimm', -0.05)
     elseif (button == 106 and CtrlUp)     then lmc_inc_xpl_variable('Rotate/md80/lights/cockpit_panel_digital_lt_dimm', 0.05)    --num *
     elseif (button == 106 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/lights/cockpit_panel_digital_lt_dimm', -0.05)
     elseif (button == 109 and CtrlUp)     then lmc_inc_xpl_variable('Rotate/md80/lights/cockpit_panel_flood_lt_dimm', 0.05)    --num -
     elseif (button == 109 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/lights/cockpit_panel_flood_lt_dimm', -0.05)

     end
     return
  end


    --Keyups:
  -- On keyups the above knowkeys should be ignored.
  if   (button == 53 or button == string.byte('T')
     or button == 54 or button == string.byte('Y')
     or button == 57 or button == string.byte('O')
     or button == 48 or button == string.byte('P')
     or button == string.byte('F') or button == string.byte('G')
     or button == string.byte('H') or button == string.byte('V')
     or button == string.byte('B') or button == string.byte('N')
     or button == string.byte('K') or button == string.byte('L')
     or button == 192 or button == 188
     or button == 190 or button == 189
     or button == 111 or button == 106
     or button == 109
     ) then return end

  if     (button == 17) then
         CtrlUp = true;

  -- F-keys :
--  elseif (button == 112 ) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_l', 1) --  F1

  elseif (button == 113 ) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_display_range', 1) --  F2
  elseif (button == 114 ) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_display_range', -1) --  F3

  elseif (button == 115 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_sensitivity', 0.1) --  F5
  elseif (button == 115 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_sensitivity', -0.1) --  F5

  elseif (button == 116 ) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_switch', -1) --  F5
  elseif (button == 117 ) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_switch', 1) --  F6
  elseif (button == 118 ) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_tilt', -1) --  F7
  elseif (button == 119 ) then lmc_inc_xpl_variable('Rotate/md80/instruments/wx_tilt', 1) --  F8


  elseif (button == 120 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_l', 1) --  F9
  elseif (button == 120 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_l', -1)
  elseif (button == 121 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_r', 1) --  F10
  elseif (button == 121 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_r', -1)


  -- Top Row:

  elseif (button == 49 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/timer_switch',1,2,1)
  elseif (button == 49 and CtrlUp) then if (lmc_get_xpl_variable('Rotate/md80/instruments/timer_switch') == 0)
         then lmc_set_xpl_variable('Rotate/md80/instruments/timer_switch', 1)
         else lmc_set_xpl_variable('Rotate/md80/instruments/timer_switch', 0)
         end
--  elseif (button == 50 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/clock_switch', 1) --  2
--  elseif (button == 50 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/instruments/clock_switch', -1)
  elseif (button == 187 and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/hydraulic/hyd_trans', 1) --  +?
  elseif (button == 187 and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/hydraulic/hyd_trans', 0)
  elseif (button == 219 and CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_electric', 1) --  ´`
  elseif (button == 219 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/hydraulic/hyd_switch_electric', -1)

  -- Letter Upper Row:
  elseif (button == 52) then lmc_xpl_command('Rotate/md80/autopilot/com1_flip_freq')
  elseif (button == 56) then lmc_xpl_command('Rotate/md80/autopilot/com2_flip_freq')
  elseif (button == 221 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_l',0.6)
  elseif (button == 186 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_r',0.6)

  -- Letter Mid Row:
  elseif (button == string.byte('D')) then lmc_xpl_command('Rotate/md80/autopilot/adf1_flip_freq')
  elseif (button == string.byte('J')) then lmc_xpl_command('Rotate/md80/autopilot/adf2_flip_freq')
  elseif (button == 222 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_l',-0.6)
  elseif (button == 191 and not CtrlUp) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_r',-0.6)

  -- Letter Lower Row:
  elseif (button == 226) then lmc_xpl_command('Rotate/md80/systems/mag_true_toggle')
--  elseif (button == 226 and CtrlUp) then lmc_set_xpl_variable('Rotate/md80/systems/mag_true', 1)
--  elseif (button == 226 and not CtrlUp) then lmc_set_xpl_variable('Rotate/md80/systems/mag_true', 0)

  --navkeys:
  elseif (button == 35) then lmc_inc_xpl_variable('Rotate/md80/instruments/transponder_mode_switch',1) -- End
  elseif (button == 46) then lmc_inc_xpl_variable('Rotate/md80/instruments/transponder_mode_switch',-1) --Del
  elseif (button == 34) then lmc_xpl_command('sim/transponder/transponder_ident') --PgDn

  --arrows:
  elseif (button == 39) then lmc_inc_xpl_variable('Rotate/md80/instruments/transponder_code_switch',-1) -- Left
  elseif (button == 37) then lmc_inc_xpl_variable('Rotate/md80/instruments/transponder_code_switch',1) -- Right
  elseif (button == 38) then lmc_xpl_command('Rotate/md80/instruments/transponder_code_up') -- Up
  elseif (button == 40) then lmc_xpl_command('Rotate/md80/instruments/transponder_code_dn') -- Down




  -- Numpad:

--  elseif (button == 96) then lmc_xpl_command('rotate/md80/cdu/Cdu_0') --numpad_0
--  elseif (button == 110) then lmc_xpl_command('rotate/md80/cdu/Cdu_0') --numpad_.
  elseif (button == 100) then lmc_set_xpl_variable('Rotate/md80/air/xfeed_valve_left',0) --numpad_4
  elseif (button == 101) then lmc_set_xpl_variable('Rotate/md80/air/xfeed_valve_right',0) --numpad_5
  elseif (button == 103) then lmc_set_xpl_variable('Rotate/md80/air/xfeed_valve_left',1) --numpad_7
  elseif (button == 104) then lmc_set_xpl_variable('Rotate/md80/air/xfeed_valve_right',1) --numpad_8
  elseif (button == 102) then lmc_inc_xpl_variable('Rotate/md80/systems/auto_brake_level',-1) --numpad_6
  elseif (button == 105) then lmc_inc_xpl_variable('Rotate/md80/systems/auto_brake_level',1) --numpad_9
  elseif (button == 107) then lmc_xpl_command('Rotate/md80/systems/auto_brake_arm') --numpad_+                    --Would like variable instead
--  elseif (button == 103) then lmc_xpl_command('rotate/md80/cdu/Cdu_7')--numpad_7
--  elseif (button == 104) then lmc_xpl_command('rotate/md80/cdu/Cdu_8')--numpad_8
--  elseif (button == 105) then lmc_xpl_command('rotate/md80/cdu/Cdu_9')--numpad_9

--  elseif (button == 110) then lmc_xpl_command('Rotate/md80/autopilot/trp_test') --numpad.
--  elseif (button == 111 and CtrlUp) then                                        --numpad/
--     lmc_set_xpl_variable('Rotate/md80/lights/flood_light_switch_l',1)
--  elseif (button == 111 and not CtrlUp) then
--     lmc_set_xpl_variable('Rotate/md80/lights/flood_light_switch_l',0)
--  elseif (button == 106) then lmc_xpl_command('Rotate/md80/systems/clear_master_caution')--numpad*
--  elseif (button == 109) then lmc_xpl_command('Rotate/md80/systems/clear_master_warning')--numpad-

  elseif not (button == 255) then --specialbuttons arrows home etc..

  print('Not yet assigned: ' .. button)
  end
end)
-- **** Pedestal / lower central panel   Keyboard END ****



--  **************************


--  **************************


--  **************************


--  **************************


-- lmc_set_handler('CH_Yoke',function(button, direction, ts)
--  print('Callback for whole Yoke: button ' .. button .. ', direction '..direction..', timestamp '..ts)
--  if (direction == 1) then
--     if (button == 0) then lmc_send_keys('T')
--     end
--  end
-- end)

lmc_set_handler('CH_Quadrant',function(button, direction, ts)
--  print('Callback for whole Quadrant: button ' .. button .. ', direction '..direction..', timestamp '..ts)
    if (direction == 1) then
           if (button == 4) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_l',0.6)
       elseif (button == 5) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_l',-0.6)
       elseif (button == 6) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_r',0.6)
       elseif (button == 7) then lmc_inc_xpl_variable('Rotate/md80/fuel/fuel_valve_ratio_r',-0.6)
       end
    end
end)

-- 1st param: device name
-- 2nd param: axis index
-- 3rd param: interval in ms
-- 4th param: minimum delta

--local elevTrim = 0

lmc_set_axis_handler('CH_Yoke',5, 100, 2000, function(val, ts)                               --Elev.TRIM
       if (val > 40000) then lmc_xpl_command_begin('sim/flight_controls/pitch_trim_down');
       elseif (val < 25000) then lmc_xpl_command_begin('sim/flight_controls/pitch_trim_up')
       else
          lmc_xpl_command_end('sim/flight_controls/pitch_trim_up')
          lmc_xpl_command_end('sim/flight_controls/pitch_trim_down')
       end
end)

--*****
Spoilerset = 0;
lmc_set_axis_handler('CH_Quadrant',0, 300, 1000, function(val, ts)   -- spoiler/speedbrake

local spoilerPositions = 6; -- antal positioner
local spoilerHhyst = 2000;  --halve hystereseværdi
local spoilerDetent = 58774;
local spoilerVmax = 65535;
local spoilerIndent = (spoilerVmax / (spoilerPositions - 1) );

      local dirty = false;
      while (val > (Spoilerset + 0.5) * spoilerIndent + spoilerHhyst)
            do Spoilerset = Spoilerset + 1
            dirty = true;
      end
      while (val < (Spoilerset - 0.5) * spoilerIndent - spoilerHhyst)
            do Spoilerset = Spoilerset - 1
            dirty = true;
      end
      if dirty then setSpoilers()
      end
end)

function setSpoilers()
         if (Spoilerset == 0) then lmc_set_xpl_variable('Rotate/md80/systems/speedbrake_position',-1)
         elseif (Spoilerset == 1) then lmc_set_xpl_variable('Rotate/md80/systems/speedbrake_position',0)
         elseif (Spoilerset == 2) then lmc_set_xpl_variable('Rotate/md80/systems/speedbrake_position',1)
         elseif (Spoilerset == 3) then lmc_set_xpl_variable('Rotate/md80/systems/speedbrake_position',2)
         elseif (Spoilerset == 4) then lmc_set_xpl_variable('Rotate/md80/systems/speedbrake_position',3)
         elseif (Spoilerset == 5) then lmc_set_xpl_variable('Rotate/md80/systems/speedbrake_position',4)
         end
end

--lmc_set_axis_handler('CH_Quadrant',1, 300, 100, function(val, ts)   -- rev 1
--  print('Callback for quadrant s5 - value ' .. val..', timestamp '..ts)
--end)





--*****  BEGIN Thrust:

thr1_offsync = 0; -- -1= quadrant below sim 0= insync 1= quadrant above sim 2= offsync unknown
thr2_offsync = 0;

atsw=0;
atmode=0;   -- -1= IAS/MACH, 0 = speed, 1 = mach,      2 = epr,      3 = fms speed, 4 = fms mach, 5 = fms epr, 6 = fms idle,  7 = fms clmp, 8 = RETD
atsubm=-1;   -- -1= no mode,  0 = CLMP,  1 = ALPHA SPD, 2 = FLAP LIM, 3 = SLAT LIM,  4 = VMO LIM,  5 = MMO LIM, 6 = LOW LIM,   7 = SPD ATL,  8 = MACH ATL
retard1 = false;
retard2 = false;

lmc_on_xpl_var_change('Rotate/md80/autopilot/at_switch', function(value)
  atsw = value
  evaluateSync()
  if(atsw==0 and retard1) then
     lmc_set_xpl_variable('sim/flightmodel/engine/ENGN_thro', 0 , 0)
     retard1 = false
  end
  if(atsw==0 and retard2) then
     lmc_set_xpl_variable('sim/flightmodel/engine/ENGN_thro', 1 , 0)
     retard2 = false
  end
end)

lmc_on_xpl_var_change('Rotate/md80/autopilot/at_mode', function(value)
  atmode = value
  evaluateSync()
end)

lmc_on_xpl_var_change('Rotate/md80/autopilot/at_sub_mode', function(value)
  atsubm = value
  evaluateSync()
end)

thq1Detent1hit = false;
thq2Detent1hit = false;

function evaluateSync()
   if (atsw==1 and not (atmode==7 or atsubm == 0)) then
     thr1_offsync = 2
     thr2_offsync = 2
     thq1Detent1hit = false;
     thq2Detent1hit = false;
  end
--  Print_AT_status()
end

--function Print_AT_status()
--  print('AT_Status:   Switch:'..atsw..'  ATmode:'..atmode..'  ATsubmode:'.. atsubm..'  thrust1_offsync:'.. thr1_offsync)
--end

ThrHyst=0.0500;
thqDetent0 = 65000;
thqDetent1 = 59200;
thqDetentHyst = 1200;

lmc_set_axis_handler('CH_Quadrant',2, 10, 500, function(val, ts)   --throttle 1
   if(atsw==1 and not (atsubm==0 or atmode==7))  then
      if (thq1Detent1hit == false and (val < (thqDetent1 + thqDetentHyst)) and (val > (thqDetent1 - thqDetentHyst)))
         then thq1Detent1hit = true
      end
   end
   if (thq1Detent1hit == true and (val > (thqDetent0 - thqDetentHyst))) then
      retard1=true
      retard2=true
      lmc_xpl_command('Rotate/md80/autopilot/at_switch_off')
      atsw=0
      thr1_offsync = 0
      thr2_offsync = 0
   end
   if(atsw==0 or atsubm==0 or atmode==7)  then
      local thq = (1 - (val / 65535));    --scale inputunits from ThrottleQuadrant
      if(thr1_offsync == 0)
         then lmc_set_xpl_variable('sim/flightmodel/engine/ENGN_thro', thq , 0)
         else
            simthr = lmc_get_xpl_variable('sim/flightmodel/engine/ENGN_thro',0);
            if (ts>sayts) then
               sayThrWarning()
               sayts = ts+3000
            end
--            if (thq1Detent1hit) then print ('true') else print('false') end
--            print(val)
--            print('thq - ThrHyst = '.. 100*(thq-ThrHyst) .. '  < simthr' .. 100*simthr .. ' AND   th + ThrHyst = '.. 100*(thq+ThrHyst) .. '  > simthr' .. 100*simthr  )
            if ((thq - ThrHyst < simthr) and (thq + ThrHyst > simthr)) then
               lmc_set_xpl_variable('sim/flightmodel/engine/ENGN_thro', thq , 0)
               thr1_offsync = 0
               sayThrWarning()
            end
      end
   end
end)

sayts = 0;
function sayThrWarning()
   if (thr1_offsync == 0) then
      if (thr2_offsync == 0)
         then lmc_say('Both synced')
--              lmc_xpl_text('Throttles Syncronized',0.7,4)
         else lmc_say('2 Not synced')
--              lmc_xpl_text('Throttle #2 not Syncronized',0.7,4)
      end
   else
      if (thr2_offsync == 0)
         then lmc_say('1 Not synced')
--              lmc_xpl_text('Throttle #1 not Syncronized',0.7,4)
         else lmc_say('1 and 2 - not synced')
--              lmc_xpl_text('Throttle #1 and #2 not Syncronized',0.7,4)
      end
   end
end

lmc_set_axis_handler('CH_Quadrant',5, 10, 500, function(val, ts)   --throttle 2
   if(atsw==1 and not (atsubm==0 or atmode==7))  then
      if (thq2Detent1hit == false and (val < (thqDetent1 + thqDetentHyst)) and (val > (thqDetent1 - thqDetentHyst)))
         then thq2Detent1hit = true
      end
   end
   if (thq1Detent2hit == true and (val > (thqDetent0 - thqDetentHyst))) then
      retard1=true
      retard2=true
      lmc_xpl_command('Rotate/md80/autopilot/at_switch_off')
      atsw=0
      thr1_offsync = 0
      thr2_offsync = 0
   end
   if(atsw==0 or atsubm==0 or atmode==7)  then
      local thq = (1 - (val / 65535));    --scale inputunits from ThrottleQuadrant
      if(thr2_offsync == 0)
         then lmc_set_xpl_variable('sim/flightmodel/engine/ENGN_thro', thq , 1)
         else
            simthr = lmc_get_xpl_variable('sim/flightmodel/engine/ENGN_thro',1);
            if (ts>sayts) then
               sayThrWarning()
               sayts = ts+3000
            end
--            if (thq2Detent1hit) then print ('true') else print('false') end
--            print(val)
--            print('thq - ThrHyst = '.. 100*(thq-ThrHyst) .. '  < simthr' .. 100*simthr .. ' AND   th + ThrHyst = '.. 100*(thq+ThrHyst) .. '  > simthr' .. 100*simthr  )
            if ((thq - ThrHyst < simthr) and (thq + ThrHyst > simthr)) then
               lmc_set_xpl_variable('sim/flightmodel/engine/ENGN_thro', thq , 1)
               thr2_offsync = 0
               sayThrWarning()
            end
      end
   end
end)

--*****  END Thrust:





--  print('Callback for quadrant s2 - value ' .. val..', timestamp '..ts)
--end)

--lmc_set_axis_handler('CH_Quadrant',5, 300, 100, function(val, ts)   -- throttle 2
--  print('Callback for quadrant s5 - value ' .. val..', timestamp '..ts)
--end)


Flapset = 2;
lmc_set_axis_handler('CH_Quadrant',3, 300, 1000, function(val, ts)   -- flaps

local flapPositions = 8; -- antal positioner
local flapHhyst = 2000;  --halve hystereseværdi
local flapDetent = 58774;
local flapVmax = 65535;
local flapIndent = (flapVmax / (flapPositions - 1) );

    local dirty = false;
    while (val > (Flapset + 0.5) * flapIndent + flapHhyst)
          do Flapset = Flapset + 1
          dirty = true;
    end
    while (val < (Flapset - 0.5) * flapIndent - flapHhyst)
          do Flapset = Flapset - 1
          dirty = true;
    end

    if dirty then setFlaps()
    end
end)

function setFlaps()
         local f0 = 0       -- up/ret
         local f1 = 0.35    -- 0
         local f2 = 0.45    --
         local f3 = 0.53    -- 11
         local f4 = 0.59    -- 15
         local f5 = 0.66    --
         local f6 = 0.75    -- 28
         local f7 = 1       -- 40

         if (Flapset == 0) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f0)
         elseif (Flapset == 1) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f1)
         elseif (Flapset == 2) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f2)
         elseif (Flapset == 3) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f3)
         elseif (Flapset == 4) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f4)
         elseif (Flapset == 5) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f5)
         elseif (Flapset == 6) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f6)
         elseif (Flapset == 7) then lmc_set_xpl_variable('Rotate/md80/systems/flap_handle_position_ratio', f7)
         end
end


--lmc_set_axis_handler('CH_Quadrant',4, 300, 1000, function(val, ts)   -- rev 2
--  print('Callback for quadrant s4 - value ' .. val..', timestamp '..ts)
--end)




-- Flightstick:
-- lmc_set_axis_handler('Stick',5, 100, 200, function(val, ts)   -- Rotation
-- print('Callback for quadrant - value ' .. val..', timestamp '..ts)
-- end)

